/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package error;

/**
 * Class representing an error during use of the software.
 * @author Lauritz Møllersen
 */
public class Error {
    private Exception exception = null;
    private int type = 1;
    private String name;
    private String text;
    
    /**
     * Constructor with all info.
     * @param tempException The Exception object.
     * @param tempType The type of Error, used for priority.
     * @param tempName The name of the Error.
     * @param tempText A short description of the error.
     */
    public Error(Exception tempException, int tempType, String tempName, String tempText) {
        exception = tempException;
        type = tempType;
        name = tempName;
        text = tempText;
    }
    
    /**
     * 
     * @param tempException
     * @param tempName
     * @param tempText
     */
    public Error(Exception tempException, String tempName, String tempText) {
        exception = tempException;
        name = tempName;
        text = tempText;
    }
    
    /**
     * 
     * @param tempName
     * @param tempText
     */
    public Error(String tempName, String tempText) {
        exception = null;
        name = tempName;
        text = tempText;
    }
    
    /**
     * 
     * @param tempType
     * @param tempName
     * @param tempText
     */
    public Error(int tempType, String tempName, String tempText) {
        exception = null;
        name = tempName;
        text = tempText;
        type = tempType;
    }
    
    @Override
    public String toString() {
        String temp = "Name: " + name + "\nDescription: " + text;
        if(exception != null) temp += "\nException: " + exception.toString();
        return temp;
    }

    /**
     * @return the exception
     */
    public Exception getException() {
        return exception;
    }

    /**
     * @param exception the exception to set
     */
    public void setException(Exception exception) {
        this.exception = exception;
    }

    /**
     * @return the type
     */
    public int getType() {
        return type;
    }

    /**
     * @param type the type to set
     */
    public void setType(int type) {
        this.type = type;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the text
     */
    public String getText() {
        return text;
    }

    /**
     * @param text the text to set
     */
    public void setText(String text) {
        this.text = text;
    }
    
}
