/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package error;

import java.util.ArrayList;
import javax.swing.JOptionPane;

/**
 * Class for logging the {@link Error}s that occur.
 * @author Lauritz Møllersen
 */
public class ErrorLogger {
    private static ArrayList<Error> errors = new ArrayList<Error>();
    private static boolean verbose;
    
    /**
     *  Default constructor.
     */
    public ErrorLogger() {
        errors = new ArrayList<Error>();
        verbose = true;
    }
    
    /**
     * Method for adding an {@link Error} to the log. Prints the error
     * if it's relevant for the user.
     * @param e The {@link Error} object.
     */
    public static void addError(Error e) {
        errors.add(e);
        if (e.getType() > 0) {
                JOptionPane.showMessageDialog(null, e.toString(), "An error has occured", JOptionPane.ERROR_MESSAGE);
        }
        if (verbose == true) {
            System.out.println(e.toString());
            if(e.getException() != null) e.getException().printStackTrace();
        }
    }
    
    /**
     * Deletes all the {@link Error}s in the log.
     */
    public static void clearErrors() {
        errors = new ArrayList<Error>();
    }
}
