/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GUI_Main.java
 *
 * Created on Nov 6, 2011, 11:27:17 PM
 */
package gui;

import gui.wizard.SinglePanelWizard;
import gui.wizard.panels.*;
import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import math.MathFunction;
import project.Project;
import plugin.Plugin;
import segmentation.Segmentation;
import view.View;
import parser.Constants;
import view.basic.BasicViewPanel;

/**
 *
 * @author Per Øyvind
 */
public class MainGUIImpl extends javax.swing.JFrame implements MainGUI, ChangeListener, WindowListener {
//ENDRING

    private Project project;

    /** Creates new form GUI_Main */
    public MainGUIImpl() {

        initComponents();
       addWindowListener(this);
        setExtendedState(JFrame.MAXIMIZED_BOTH);
        setTitle("Revolve Analyzer");
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        jTabbedPane1.addChangeListener(this);
        BufferedImage image = null;
        //ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource("view/basic/logo.png"));
        try {
            image = ImageIO.read(getClass().getClassLoader().getResource("gui/icon.png"));
        } catch (IOException ex) {
            Logger.getLogger(BasicViewPanel.class.getName()).log(Level.SEVERE, null, ex);
        }
        setIconImage(image);


        Project p = new Project();
        p.init(this);
        setProject(p);
    }

    /**
     * @param pos  
     */
    public void addView(View v, int pos) {
        int position;
        if (pos > jTabbedPane1.getTabCount()) {
            position = jTabbedPane1.getTabCount();
        } else {
            position = pos;
        }
        String title = v.getTitle();
        jTabbedPane1.add(v.getViewPanel(), position);

        jTabbedPane1.setTabComponentAt(position, new ViewTabHeader(title, v));
        jTabbedPane1.setSelectedIndex(position);
        if (v.getPlugins() != null && v.getPlugins().size() != 0) {
            setCurrentPlugin(v.getPlugins().get(0));
        } else {
            setCurrentPlugin(null);
        }
    }

    public void removeView(View v) {
        String title = v.getTitle();
        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            if (((ViewTabHeader) jTabbedPane1.getTabComponentAt(i)).getTitle().equals(title)) {
                jTabbedPane1.remove(i);
                break;
            }
        }
    }

    /**
     * 
     */
    public void clearViews() {
        jTabbedPane1.removeAll();
    }

    public void setProject(Project p) {
        p.setGui(this);
        String frameTitle;
        if (p.getFile() != null) {
            frameTitle = "Revolve Analyzer - " + p.getFile().toString();
        } else {
            frameTitle = "Revolve Analyzer - Untitled Project";
        }
        setFrameTitle(frameTitle);
        this.project = p;
        clearViews();
        for (int i = 0; i < p.getViews().size(); i++) {
            addView(p.getViews().get(i), i);
        }
        setCurrentPlugin(null);
        jMenuItem20.setEnabled(false);
        jMenuItem21.setEnabled(false);
        jMenuItem20.setText("Undo");
        jMenuItem21.setText("Redo");

    }

    public void setUndoEnabled(boolean b) {
        jMenuItem20.setEnabled(b);
        // controlPanel1.getToolBoxPanel().setUndoEnabled(b);
    }

    /**
     * 
     * @param b
     */
    public void setRedoEnabled(boolean b) {
        jMenuItem21.setEnabled(b);
        //controlPanel1.getToolBoxPanel().setRedoEnabled(b);
    }

    public void setCurrentPlugin(Plugin p) {

        controlPanel1.setFocusedPlugin(p);

    }


    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane2 = new javax.swing.JTabbedPane();
        jPanel6 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        controlPanel1 = new gui.ControlPanel(); controlPanel1.init(this);
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu5 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem22 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem20 = new javax.swing.JMenuItem();
        jMenuItem21 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem16 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem11 = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JPopupMenu.Separator();
        jMenuItem15 = new javax.swing.JMenuItem();
        jMenuItem14 = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenuItem10 = new javax.swing.JMenuItem();
        jMenuItem13 = new javax.swing.JMenuItem();
        jMenuItem12 = new javax.swing.JMenuItem();
        jMenuItem18 = new javax.swing.JMenuItem();
        jMenuItem17 = new javax.swing.JMenuItem();
        jMenuItem19 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(204, 204, 204));

        jPanel6.setBackground(new java.awt.Color(204, 204, 204));

        jSplitPane1.setDividerLocation(280);
        jSplitPane1.setLeftComponent(controlPanel1);
        jSplitPane1.setRightComponent(jTabbedPane1);

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 1215, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 623, Short.MAX_VALUE)
                .addContainerGap())
        );

        jMenu5.setText("Project");

        jMenuItem1.setText("New project");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem1);

        jMenuItem5.setText("Open project");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem5);

        jMenuItem7.setText("Save project");
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem7);

        jMenuItem22.setText("Save project as..");
        jMenuItem22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem22ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem22);
        jMenu5.add(jSeparator1);

        jMenuItem3.setText("Import data");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem3);
        jMenu5.add(jSeparator2);

        jMenuItem6.setText("Exit");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu5.add(jMenuItem6);

        jMenuBar1.add(jMenu5);

        jMenu1.setText("Edit");

        jMenuItem20.setText("Undo");
        jMenuItem20.setEnabled(false);
        jMenuItem20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem20ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem20);

        jMenuItem21.setText("Redo");
        jMenuItem21.setEnabled(false);
        jMenuItem21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem21ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem21);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Channels");

        jMenuItem4.setText("Configure channels");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem4);

        jMenuItem16.setText("Configure math channels");
        jMenuItem16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem16ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem16);

        jMenuBar1.add(jMenu2);

        jMenu3.setText("View");

        jMenuItem2.setText("New view");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem2);

        jMenuItem11.setText("Delete view");
        jMenuItem11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem11ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem11);
        jMenu3.add(jSeparator4);

        jMenuItem15.setText("Open view");
        jMenuItem15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem15ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem15);

        jMenuItem14.setText("Save view");
        jMenuItem14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem14ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem14);

        jMenuBar1.add(jMenu3);

        jMenu4.setText("Plugins");

        jMenuItem8.setText("LineChart");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem8);

        jMenuItem9.setText("Map");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem9);

        jMenuItem10.setText("NotePad");
        jMenuItem10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem10ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem10);

        jMenuItem13.setText("Playback");
        jMenuItem13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem13ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem13);

        jMenuItem12.setText("Report");
        jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem12ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem12);

        jMenuItem18.setText("TimeSlip");
        jMenuItem18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem18ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem18);

        jMenuItem17.setText("Video");
        jMenuItem17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem17ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem17);

        jMenuItem19.setText("XYChart");
        jMenuItem19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem19ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem19);

        jMenuBar1.add(jMenu4);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
    boolean saved;

    if (project != null) {
        saved = project.isSaved();
    } else {
        saved = true;
    }

    if (!saved) {
        int check = saveCheck();
        if (check == 2) {
            return;
        }
        if (check == 0) {
            if (project.getFile() == null) {
                final JFileChooser fc = new JFileChooser();
                fc.setApproveButtonText("Save");
                fc.setDialogTitle("Save Project As..");
                int n = fc.showOpenDialog(this);
                if (n == 1) {
                    return;
                }
                File f = fc.getSelectedFile();
                if (f != null) {
                    project.saveToFile(f);
                }
            } else {
                project.saveToFile(project.getFile());

            }
        }
        if (check != 2) {
            Project p = new Project();
            p.init(this);
            setProject(p);
        }
    } else {
        Project p = new Project();
        p.init(this);
        setProject(p);
    }
}//GEN-LAST:event_jMenuItem1ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
    project.createNewView(view.basic.BasicView.class, true);
    //new SinglePanelWizard(this, true, project, new NewViewPanel()).setVisible(true);
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
    final JFileChooser fc = new JFileChooser();
    fc.setApproveButtonText("Open");
    fc.setDialogTitle("Import Data");
    fc.showOpenDialog(this);
    File f = fc.getSelectedFile();
    if (f != null) {
        final JFileChooser fc2 = new JFileChooser();
        fc2.setApproveButtonText("Open");
        fc2.setDialogTitle("Select Calibration Properties File");
        fc2.showOpenDialog(this);
        File propFile = fc2.getSelectedFile();
        Properties prop;
        if (propFile != null) {
            prop = MathFunction.readProperties(propFile.getAbsolutePath());
        } else {
            prop = new Properties();
        }
        project.importData(f.getAbsolutePath(), prop);
        Segmentation s = new Segmentation();
        s.createLaps(project.getChannelType(Constants.CHAN_LAP));
        project.setSegmentation(s);
    }




}//GEN-LAST:event_jMenuItem3ActionPerformed

private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
    new SinglePanelWizard(this, true, project, new ConfigChannelsPanel(this, this.project)).setVisible(true);


}//GEN-LAST:event_jMenuItem4ActionPerformed

private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
    boolean saved;
    if (project != null) {
        saved = project.isSaved();
    } else {
        saved = true;
    }
    if (!saved) {
        int check = saveCheck();
        if (check == 2) {
            return;
        }
        if (check == 0) {
            if (project.getFile() == null) {
                final JFileChooser fc = new JFileChooser();
                fc.setApproveButtonText("Save");
                fc.setDialogTitle("Save Project As..");
                int n = fc.showOpenDialog(this);
                if (n == 1) {
                    return;
                }
                File f = fc.getSelectedFile();
                if (f != null) {
                    project.saveToFile(f);
                }
            } else {
                project.saveToFile(project.getFile());

            }
        }
        if (check != 2) {
            this.dispose();
        }
    } else {
        this.dispose();
    }
}//GEN-LAST:event_jMenuItem6ActionPerformed

private void jMenuItem14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem14ActionPerformed
    final JFileChooser fc = new JFileChooser();
    fc.setApproveButtonText("Save");
    fc.setDialogTitle("Save View");
    fc.showOpenDialog(this);
    File f = fc.getSelectedFile();
    if (f != null) {
        
                project.saveViewToFile(getCurrentView(), fc.getSelectedFile());
           
    }

}//GEN-LAST:event_jMenuItem14ActionPerformed

private void jMenuItem15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem15ActionPerformed
    final JFileChooser fc = new JFileChooser();
    fc.setApproveButtonText("Open");
    fc.setDialogTitle("Open View");
    fc.showOpenDialog(this);
    File f = fc.getSelectedFile();

    if (f != null) {
        project.loadViewFromFile(fc.getSelectedFile());
    }
}//GEN-LAST:event_jMenuItem15ActionPerformed

private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
    if (project.getFile() == null) {
        final JFileChooser fc = new JFileChooser();
        fc.setApproveButtonText("Save");
        fc.setDialogTitle("Save Project");
        fc.showOpenDialog(this);
        File f = fc.getSelectedFile();
        if (f != null) {
            project.saveToFile(f);
        }
    } else {
        project.saveToFile(project.getFile());

    }
}//GEN-LAST:event_jMenuItem7ActionPerformed

private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
    boolean saved;
    if (project != null) {
        saved = project.isSaved();
    } else {
        saved = true;
    }
    if (!saved) {
        int check = saveCheck();
        if (check == 2) {
            return;
        }
        if (check == 0) {
            if (project.getFile() == null) {
                final JFileChooser fc = new JFileChooser();
                fc.setApproveButtonText("Save");
                fc.setDialogTitle("Save Project As..");
                int n = fc.showOpenDialog(this);
                if (n == 1) {
                    return;
                }
                File f = fc.getSelectedFile();
                if (f != null) {
                    project.saveToFile(f);
                }
            } else {
                project.saveToFile(project.getFile());

            }
        }
        if (check != 2) {
            final JFileChooser fc = new JFileChooser();
            fc.setApproveButtonText("Open");
            fc.setDialogTitle("Open Project");
            fc.showOpenDialog(this);
            File f = fc.getSelectedFile();

            if (f != null) {
                Project p = Project.loadFromFile(fc.getSelectedFile());
               if(p!=null){ p.init(this);
                setProject(p);
            }}
        }
    } else {
        final JFileChooser fc = new JFileChooser();
        fc.setApproveButtonText("Open");
        fc.setDialogTitle("Open Project");
        fc.showOpenDialog(this);
        File f = fc.getSelectedFile();

        if (f != null) {
            Project p = Project.loadFromFile(fc.getSelectedFile());
             if(p!=null){ p.init(this);
                setProject(p);
            }
        }
    }

}//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jMenuItem16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem16ActionPerformed
        new SinglePanelWizard(this, true, project, new MathChannels(this, this.project)).setVisible(true);
    }//GEN-LAST:event_jMenuItem16ActionPerformed

private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
    project.createNewPlugin(plugin.linechart.LineChartPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem8ActionPerformed

private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
    project.createNewPlugin(plugin.map.MapPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem9ActionPerformed

private void jMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem10ActionPerformed
    project.createNewPlugin(plugin.notepad.NotepadPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem10ActionPerformed

private void jMenuItem13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem13ActionPerformed
    project.createNewPlugin(plugin.playback.PlaybackPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem13ActionPerformed

private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
    project.createNewPlugin(plugin.report.ReportPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem12ActionPerformed

private void jMenuItem17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem17ActionPerformed
    project.createNewPlugin(plugin.video.VideoPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem17ActionPerformed

private void jMenuItem20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem20ActionPerformed
    project.undo();

}//GEN-LAST:event_jMenuItem20ActionPerformed

private void jMenuItem21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem21ActionPerformed
    project.redo();
}//GEN-LAST:event_jMenuItem21ActionPerformed

private void jMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem11ActionPerformed
    project.removeView(getCurrentView(), true);
}//GEN-LAST:event_jMenuItem11ActionPerformed

private void jMenuItem19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem19ActionPerformed
    project.createNewPlugin(plugin.xy.XYChartPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem19ActionPerformed
 public View getCurrentView() {
        Component viewGuiComponent = jTabbedPane1.getSelectedComponent();
        if(viewGuiComponent!=null){
        for(View v: project.getViews()){
            if(v.getViewPanel().equals(viewGuiComponent))return v;
        }}
        return null;
    }
private void jMenuItem22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem22ActionPerformed
    final JFileChooser fc = new JFileChooser();
    fc.setApproveButtonText("Save");
    fc.setDialogTitle("Save Project As..");
    fc.showOpenDialog(this);
    File f = fc.getSelectedFile();
    if (f != null) {
        project.saveToFile(fc.getSelectedFile());
        project.setFile(fc.getSelectedFile());
    }
}//GEN-LAST:event_jMenuItem22ActionPerformed

private void jMenuItem18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem18ActionPerformed
project.createNewPlugin(plugin.timeslip.TimeSlipPlugin.class, getCurrentView(), true);
}//GEN-LAST:event_jMenuItem18ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private gui.ControlPanel controlPanel1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenu jMenu5;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem11;
    private javax.swing.JMenuItem jMenuItem12;
    private javax.swing.JMenuItem jMenuItem13;
    private javax.swing.JMenuItem jMenuItem14;
    private javax.swing.JMenuItem jMenuItem15;
    private javax.swing.JMenuItem jMenuItem16;
    private javax.swing.JMenuItem jMenuItem17;
    private javax.swing.JMenuItem jMenuItem18;
    private javax.swing.JMenuItem jMenuItem19;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem20;
    private javax.swing.JMenuItem jMenuItem21;
    private javax.swing.JMenuItem jMenuItem22;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator4;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    // End of variables declaration//GEN-END:variables

    /**
     * 
     * @return
     */
    @Override
    public Rectangle getViewAreaDimension() {
        Rectangle d = jTabbedPane1.getVisibleRect();
        return d;
    }

    /**
     * 
     * @param text
     */
    @Override
    public void setUndoText(String text) {
        jMenuItem20.setText(text);
    }

    /**
     * 
     * @param text
     */
    @Override
    public void setRedoText(String text) {
        jMenuItem21.setText(text);
    }

    /**
     * 
     */
    @Override
    public void viewTitlesChanged() {
        if (project.getViews().size() != jTabbedPane1.getTabCount()) {
        } else {
            for (View v : project.getViews()) {
                for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
                    if (v.getViewPanel().equals(jTabbedPane1.getComponentAt(i))) {
                        ((ViewTabHeader) jTabbedPane1.getTabComponentAt(i)).setTitle(v.getTitle());

                        break;

                    }
                }
            }
        }
    }

    /**
     * 
     * @return
     */
    @Override
    public Plugin getCurrentPlugin() {
        for(Plugin p: getCurrentView().getPlugins()){
            if(p.equals(controlPanel1.getFocusedPlugin()))return p;
        }
        return null;
        
    }

    /**
     * 
     * @param frameTitle
     */
    public void setFrameTitle(String frameTitle) {
        setTitle(frameTitle);
    }

    private int saveCheck() {
        if (project != null) {
            if (!project.getUndoHistory().isEmpty()) {
                Object[] options = {"Yes",
                    "No",
                    "Cancel"};
                int n = JOptionPane.showOptionDialog(this,
                        "Do you want to save the changes done to the current project?",
                        "New Project",
                        JOptionPane.YES_NO_CANCEL_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,
                        options,
                        options[2]);
                return n;


            }
        }
        return -1;
    }

    @Override
    public void stateChanged(ChangeEvent e) {

        if (e.getSource().equals(jTabbedPane1)) {

            if (project != null) {
                View v = getCurrentView();
                if (v != null) {
                    ArrayList<Plugin> plugins = v.getPlugins();
                    if (plugins != null && plugins.size() > 0) {

                        setCurrentPlugin(plugins.get(0));
                    } else {
                        setCurrentPlugin(null);
                    }
                }
            }

        }
    }

    /**
     * 
     * @param classes
     */
    @Override
    public void addExternalPluginEntries(ArrayList<Class> classes) {
       for(Class c: classes){
            final Class clazz = c;
            JMenuItem item = new JMenuItem(c.getName().substring(c.getName().lastIndexOf(".")+1));
          item.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                project.createNewPlugin(clazz, getCurrentView(), true);
            }
        });
            jMenu4.add(item);
        }
    repaint();
    }

    @Override
    public void windowOpened(WindowEvent e) {
        
    }

    @Override
    public void windowClosing(WindowEvent e) {
        jMenuItem6ActionPerformed(null);
    }

    @Override
    public void windowClosed(WindowEvent e) {
        
    }

    @Override
    public void windowIconified(WindowEvent e) {
        
    }

    @Override
    public void windowDeiconified(WindowEvent e) {
        
    }

    @Override
    public void windowActivated(WindowEvent e) {
        
    }

    @Override
    public void windowDeactivated(WindowEvent e) {
        
    }
  
 
}