/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ViewTabHeader.java
 *
 * Created on Nov 7, 2011, 1:30:51 AM
 */
package gui;

import java.awt.Color;
import view.View;
import javax.swing.JTabbedPane;

/**
 * This class is used to extend the functionality of the JTabbedPane
 * with headers having buttons to close the current tab.
 * @author Per Øyvind
 */
public class ViewTabHeader extends javax.swing.JPanel {
    private String title;
    private final View view;

    /** Creates new form ViewTabHeader
     * @param title Tab title
     * @param v The tab's view
     */
    public ViewTabHeader(String title, View v) {
        initComponents();
        this.view = v;
        this.title = title;
        jLabel1.setText(title);
      jTextField1.setVisible(false);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();

        setOpaque(false);
        setLayout(new java.awt.BorderLayout());

        jLabel2.setBackground(new java.awt.Color(153, 153, 153));
        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jLabel2.setText("x");
        jLabel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jLabel2MouseExited(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jLabel2MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jLabel2MouseReleased(evt);
            }
        });
        add(jLabel2, java.awt.BorderLayout.LINE_END);

        jPanel1.setOpaque(false);
        jPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jPanel1MouseEntered(evt);
            }
        });
        jPanel1.setLayout(new java.awt.BorderLayout());

        jTextField1.setText("jTextField1");
        jTextField1.setMaximumSize(new java.awt.Dimension(2147483647, 20));
        jTextField1.setPreferredSize(new java.awt.Dimension(150, 20));
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField1FocusLost(evt);
            }
        });
        jPanel1.add(jTextField1, java.awt.BorderLayout.PAGE_START);

        jLabel1.setText("jLabel1");
        jLabel1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jLabel1.setMaximumSize(new java.awt.Dimension(41, 20));
        jLabel1.setMinimumSize(new java.awt.Dimension(41, 20));
        jLabel1.setPreferredSize(new java.awt.Dimension(150, 20));
        jLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel1MouseClicked(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel1MouseEntered(evt);
            }
        });
        jPanel1.add(jLabel1, java.awt.BorderLayout.PAGE_END);

        add(jPanel1, java.awt.BorderLayout.LINE_START);
    }// </editor-fold>//GEN-END:initComponents

private void jLabel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseClicked
if(evt.getClickCount()>1){
    jTextField1.setText(jLabel1.getText());
    jTextField1.setVisible(true);
    jLabel1.setVisible(false);
   jTextField1.requestFocusInWindow();
   jTextField1.selectAll();
    repaint();
} else {
    JTabbedPane j = ((JTabbedPane)this.getParent().getParent());
    j.setSelectedComponent(view.getViewPanel());
        

}

}//GEN-LAST:event_jLabel1MouseClicked

private void jLabel2MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel2MousePressed
 jLabel2.setForeground(Color.RED);
}//GEN-LAST:event_jLabel2MousePressed

private void jLabel2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel2MouseReleased
  jLabel2.setForeground(Color.BLACK);
        view.getParentProject().removeView(view, true);
}//GEN-LAST:event_jLabel2MouseReleased

private void jLabel2MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel2MouseExited
jLabel2.setForeground(Color.BLACK);
}//GEN-LAST:event_jLabel2MouseExited

private void jTextField1FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField1FocusLost
this.view.setTitle(jTextField1.getText(), true);
    jTextField1.setVisible(false);

jLabel1.setVisible(true);
    
    repaint();
}//GEN-LAST:event_jTextField1FocusLost

private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
this.view.setTitle(jTextField1.getText(), true);
    jTextField1.setVisible(false);

jLabel1.setVisible(true);
   
    repaint();
    
}//GEN-LAST:event_jTextField1ActionPerformed

private void jLabel1MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseEntered


}//GEN-LAST:event_jLabel1MouseEntered

private void jPanel1MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseEntered

}//GEN-LAST:event_jPanel1MouseEntered

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables

    /**
     * 
     * @return
     */
    public String getTitle() {
       return title;
       
    }

    /**
     * 
     * @param s
     */
    public void setTitle(String s){
    this.title = s;
    jLabel1.setText(s);
}
  
}
