/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CalibrateChannelPanel.java
 *
 * Created on Nov 12, 2011, 9:22:15 PM
 */
package gui.wizard.panels;

import channel.Channel;
import error.ErrorLogger;
import gui.wizard.Wizard;
import gui.wizard.WizardPanel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import math.Polynomial;

/**
 *
 * @author Lauritz Møllersen
 * Class for calibrating a specific channel.
 */
public class CalibrateChannelPanel extends javax.swing.JPanel implements WizardPanel {

    private Wizard wizard;
    private Channel channel;
    private Polynomial polynomials;
    private Float[] floats = new Float[7];
    private int size = 0;

    /** Creates new form CalibrateChannelPanel
     * @param chan 
     */
    public CalibrateChannelPanel(Channel chan) {
        channel = chan;
        polynomials = chan.getPolynomials();

        if (polynomials != null) {
            for (int i = 0; i < polynomials.size(); i++) {
                floats[i] = polynomials.get(i);
                size++;
            }
        }
        initComponents();
        updateUInew();
    }

    /**
     * 
     * @return
     */
    @Override
    public boolean execute() {
        polynomials = new Polynomial();
        for (int i = 0; i < size; i++) {
            polynomials.add(floats[i]);
        }
        channel.setPolynomials(polynomials);
        math.Calibrator.calibrate(channel);
        return true;
    }

    /**
     * 
     * @param w
     */
    @Override
    public void setWizard(Wizard w) {
        this.wizard = w;
    }

    /**
     * 
     * @return
     */
    @Override
    public JPanel getPanel() {
        return this;
    }

    /**
     * 
     */
    @Override
    public void initData() {
        // fill list here
    }

    /**
     * 
     */
    public void updateUInew() {
        final StringBuilder ret = new StringBuilder();
        for (int x = size - 1; x > -1; x--) {
            ret.append(floats[x] + (x > 0 ? "x^" + x + " + " : ""));
        }
        jTextField1.setText(ret.toString());
        updateUI();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        addButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        clearButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList(floats);
        editButton = new javax.swing.JButton();

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel1.setText("Calibrate channel");

        jLabel5.setText("Polynom");
        jLabel5.setToolTipText("");

        jLabel6.setText("Example: a0 + a1x + a2x^2 + a3x^3 + a4x^4");
        jLabel6.setToolTipText("");

        addButton.setText("Add");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        removeButton.setText("Remove");
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        clearButton.setText("Clear");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Polynom");

        jTextField1.setEditable(false);

        jList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jList1.setAutoscrolls(false);
        jList1.setFixedCellHeight(13);
        jList1.setFixedCellWidth(60);
        jScrollPane1.setViewportView(jList1);

        editButton.setText("Edit");
        editButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(removeButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(clearButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(editButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(addButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel5)
                                        .addGap(55, 55, 55)
                                        .addComponent(jLabel6))))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 274, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(addButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(editButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(removeButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(clearButton))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 124, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(31, 31, 31))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        if (size < 7) {
            try {
                String floatString = (String) JOptionPane.showInputDialog(null, "Enter value. Example \"2.34e-10\" or \"5\":",
                        "Add polynomial", JOptionPane.PLAIN_MESSAGE, null, null, "");
                Float f = Float.parseFloat(floatString);
                floats[size] = f;
                size++;
            } catch (NumberFormatException e) {
                ErrorLogger.addError(new error.Error(e, 1, "Formatting error", "Input is not a number."));
            } catch (NullPointerException e) {
                ErrorLogger.addError(new error.Error(e, 0, "Formatting error", "No input."));
            }
            updateUInew();
        } else {
            ErrorLogger.addError(new error.Error("Too many polynomials", "Delete a polynomial in order to add a new one, or use the Edit button."));
        }


    }//GEN-LAST:event_addButtonActionPerformed

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        int index = jList1.getSelectedIndex();

        for (int i = index + 1; i < size; i++) {
            floats[i - 1] = floats[i];
        }
        floats[size - 1] = null;

        size--;

        updateUInew();
    }//GEN-LAST:event_removeButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        // CLEAR
        for (int i = 0; i < floats.length; i++) {
            floats[i] = null;
        }
        size = 0;

        updateUInew();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void editButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editButtonActionPerformed
        try {
            String floatString = (String) JOptionPane.showInputDialog(null, "Enter value. Example \"2.34e-10\" or \"5\":",
                    "Edit polynomial", JOptionPane.PLAIN_MESSAGE, null, null, "");
            Float f = Float.parseFloat(floatString);
            floats[jList1.getSelectedIndex()] = f;
        } catch (NumberFormatException e) {
            ErrorLogger.addError(new error.Error(e, 1, "Formatting error", "Input is not a number."));
        } catch (NullPointerException e) {
            ErrorLogger.addError(new error.Error(e, 0, "Formatting error", "No input."));
        }
        updateUInew();
    }//GEN-LAST:event_editButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton editButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JButton removeButton;
    // End of variables declaration//GEN-END:variables
}
