/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ConfigChannelsPanel.java
 *
 * Created on Nov 12, 2011, 9:14:30 PM
 */
package gui.wizard.panels;

import channel.Channel;
import gui.MainGUIImpl;
import gui.wizard.SinglePanelWizard;
import gui.wizard.Wizard;
import gui.wizard.WizardPanel;
import java.util.ArrayList;
import javax.swing.JPanel;
import plugin.Plugin;
import project.Project;
import view.View;

/**
 *
 * @author Lauritz Møllersen
 */
public class ConfigChannelsPanel extends javax.swing.JPanel implements WizardPanel {
    private Wizard wizard;
    private MainGUIImpl maingui;
    private Project p;
    private String[] chanStrings;
    private Channel[] tempChannels;
    private ArrayList<Channel> channels;
    private Channel selectedChan;
    private TypeInt[] types;

    /** Creates new form ConfigChannelsPanel
     * @param maingui 
     * @param p 
     */
    public ConfigChannelsPanel(MainGUIImpl maingui, Project p) {
        this.maingui = maingui;
        this.p = p;
        channels = p.getChannels();
        tempChannels = new Channel[channels.size()];
        
        Channel tempChan;
        for(int i = 0; i < channels.size(); i++) {
            tempChan = channels.get(i);
            tempChannels[i] = new Channel(tempChan.getName(), tempChan.getType());
        }
        
        // could have used Map or HashMap here, of course
        
        types = new TypeInt[] {new TypeInt(-1, "Math"), new TypeInt(0, "Other"), new TypeInt(1, "Distance"), 
            new TypeInt(2, "Time"), new TypeInt(3, "Speed"), new TypeInt(4, "Throttle"), 
            new TypeInt(5, "Brake"), new TypeInt(6, "Lateral Acc"), new TypeInt(7, "Lap"),
            new TypeInt(8, "GPS Position X"), new TypeInt(9, "GPS Position Y")};
        
        // -1 = math/created, 1 = distance, 2 = time, 3 = speed, 4 = throttle, 5 = brake, 6 = latacc, 7 = lap, gps pos x = 8, gps pos y = 9
        
        chanStrings = p.getChanStrings();
        initComponents();
        
        jList1.setSelectedIndex(0);
        setSelectedChan();
        jCheckBox1.setSelected(p.isGps());
    }
    
    private TypeInt findType(int number) {
        TypeInt temp;
        for(int i = 0; i < types.length; i++) {
            temp = types[i];
            if(temp.getNumber() == number) return temp;
        }
        return types[1];
    }
    
    private void setSelectedChan() {
        selectedChan = (Channel) jList1.getSelectedValue();
        nameTextField.setText(selectedChan.getName());
        typeComboBox.setSelectedItem(findType(selectedChan.getType()));
    }
    
    private class TypeInt {
        private int number;
        private String string;
        
        public TypeInt(int number, String string) {
            this.number = number;
            this.string = string;
        }
        
        @Override
        public String toString() {
            return number + " - " + string;
        }

        /**
         * @return the number
         */
        public int getNumber() {
            return number;
        }

        /**
         * @param number the number to set
         */
        public void setNumber(int number) {
            this.number = number;
        }

        /**
         * @return the string
         */
        public String getString() {
            return string;
        }

        /**
         * @param string the string to set
         */
        public void setString(String string) {
            this.string = string;
        }        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList(tempChannels);
        jLabel3 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        typeComboBox = new javax.swing.JComboBox();
        jCheckBox1 = new javax.swing.JCheckBox();

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel1.setText("Configure channels");

        jLabel2.setText("Channels");
        jLabel2.setToolTipText("");

        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jList1);

        jLabel3.setText("Name");
        jLabel3.setToolTipText("");

        nameTextField.setEditable(false);

        jButton2.setText("Calibration...");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel5.setText("Type");

        typeComboBox.setModel(new javax.swing.DefaultComboBoxModel(types));

        jCheckBox1.setText("Use GPS for map");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(41, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 45, Short.MAX_VALUE)
                        .addComponent(jLabel5))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 92, Short.MAX_VALUE)
                        .addComponent(jLabel3)))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(typeComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(nameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE))
                    .addComponent(jButton2)
                    .addComponent(jCheckBox1))
                .addGap(29, 29, 29))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 21, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(typeComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jCheckBox1)
                        .addGap(30, 30, 30))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(88, 88, 88))
        );
    }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    Channel chan = channels.get(jList1.getSelectedIndex());
    
    new SinglePanelWizard(maingui, true, p, new CalibrateChannelPanel(chan)).setVisible(true);
    

}//GEN-LAST:event_jButton2ActionPerformed

    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        if(selectedChan != null) {
            selectedChan.setName(nameTextField.getText());
            selectedChan.setType(((TypeInt)typeComboBox.getSelectedItem()).getNumber());
        }
        setSelectedChan();
        
    }//GEN-LAST:event_jList1ValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JComboBox typeComboBox;
    // End of variables declaration//GEN-END:variables

    /**
     * 
     * @return
     */
    @Override
    public boolean execute() {
        p.setGps(jCheckBox1.isSelected());
        jList1ValueChanged(null);
        Channel temp;
        try {
            for(int i = 0; i < channels.size(); i++) {
                temp = channels.get(i);
                temp.setName(tempChannels[i].getName());
                temp.setType(tempChannels[i].getType());
            }
            for(View v: p.getViews()) {
                for(Plugin p: v.getPlugins()) {
                    p.channelsChanged();
                }
            }
            return true;
        } catch (Exception e) {
            error.ErrorLogger.addError(new error.Error(e, "Error configuring channels", "Something is wrong with the new names of the channels."));
            return false;
        }
        
    }

    /**
     * 
     * @param w
     */
    @Override
    public void setWizard(Wizard w) {
       this.wizard = w;
    }

    /**
     * 
     * @return
     */
    @Override
    public JPanel getPanel() {
        return this;
    }

    /**
     * 
     */
    @Override
    public void initData() {
        // fill list here
    }
}
