/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MathChannels.java
 *
 * Created on 19.mar.2012, 10:04:12
 */
package gui.wizard.panels;

import channel.Channel;
import gui.MainGUIImpl;
import gui.wizard.SinglePanelWizard;
import gui.wizard.Wizard;
import gui.wizard.WizardPanel;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import project.Project;

/**
 *
 * @author Lauritz Møllersen
 */
public class MathChannels extends javax.swing.JPanel implements WizardPanel {

    private Wizard wizard;
    private Project p;
    private DefaultListModel listModel;
    private MainGUIImpl maingui;
    
    /** Creates new form MathChannels
     * @param maingui 
     * @param p 
     */
    public MathChannels(MainGUIImpl maingui, Project p) {
        this.p = p;
        this.maingui = maingui;
        ArrayList<Channel> mathChans = p.getMathChannels();

        listModel = new DefaultListModel();
        for(int i = 0; i < mathChans.size(); i++) {
            listModel.addElement(mathChans.get(i));
        }
        
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel1.setText("Math channels");

        jList1.setModel(listModel);
        jScrollPane1.setViewportView(jList1);

        jLabel2.setText("Math channels");

        jButton2.setText("Delete");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Create new");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 142, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jLabel2)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2)))
                .addContainerGap(99, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        new SinglePanelWizard(maingui, true, p, new MathChannelsAdd(this, p)).setVisible(true);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        Object temp = jList1.getSelectedValue();
        listModel.removeElement(temp);
    }//GEN-LAST:event_jButton2ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

    /**
     * 
     * @param chan
     */
    public void addChannel(Channel chan) {
        listModel.addElement(chan);
    }

    /**
     * 
     * @return
     */
    @Override
    public boolean execute() {
        final int size = listModel.size();
        Channel[] chans = new Channel[size];
        Object[] objectArray = listModel.toArray();
        for(int i = 0; i < size; i++) {
            chans[i] = (Channel) objectArray[i];
        }
        p.setMathChannels(chans);
        return true;
    }

    /**
     * 
     * @param w
     */
    @Override
    public void setWizard(Wizard w) {
       this.wizard = w;
    }

    /**
     * 
     * @return
     */
    @Override
    public JPanel getPanel() {
        return this;
    }

    /**
     * 
     */
    @Override
    public void initData() {
        // fyll liste her
    }
    
    /**
     * 
     * @return
     */
    public Wizard getWizard() {
        return this.wizard;
    }


}
