/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.wizard.panels;

import channel.Channel;
import gui.wizard.Wizard;
import gui.wizard.WizardPanel;
import javax.swing.JPanel;
import math.MathFunction;
import project.Project;

/**
 *
 * @author Lauritz Møllersen
 */
public class MathChannelsAdd extends javax.swing.JPanel implements WizardPanel {
    private Wizard wizard;
    private String[] functions;
    private MathChannels mc;
    private Project p;
    private Channel[] chanArray;
    
    /**
     * Creates new form MathChannelsAdd
     * @param mc
     * @param p  
     */
    public MathChannelsAdd(MathChannels mc, Project p) {
        this.mc = mc;
        this.p = p;
        chanArray = p.getChannelsArray();
        functions = new String[]{"Average of", "Derivative", "+ plus", "* times", "- minus", "/ divided by"};
        initComponents();
    }
    
    /**
     * 
     * @return
     */
    @Override
    public boolean execute() {
        final String name = jTextField1.getText();
        final Channel chan1 = (Channel) jComboBox1.getSelectedItem();
        final Channel chan2 = (Channel) jComboBox3.getSelectedItem();
        Channel newChan = null;
        final int index = jComboBox2.getSelectedIndex();
        switch (index) {
            case 0: {
                newChan = MathFunction.averageChan(chan1, chan2, name);
                break;
            }
            case 1: {
                newChan = MathFunction.derivate(chan1, name);
                break;
            }
            case 2: {
                newChan = MathFunction.add(chan1, chan2, name);
                break;
            }
            case 3: {
                newChan = MathFunction.multiply(chan1, chan2, name);
                break;
            }
            case 4: {
                newChan = MathFunction.subtract(chan1, chan2, name);
                break;
            }
            case 5: {
                newChan = MathFunction.divide(chan1, chan2, name);
                break;
            }
        }
        if(newChan != null) { 
            mc.addChannel(newChan);
            return true;
        }
        return false;
    }

    /**
     * 
     * @param w
     */
    @Override
    public void setWizard(Wizard w) {
       this.wizard = w;
    }

    /**
     * 
     * @return
     */
    @Override
    public JPanel getPanel() {
        return this;
    }

    /**
     * 
     */
    @Override
    public void initData() {
        // fyll liste her
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jComboBox2 = new javax.swing.JComboBox();
        jComboBox3 = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();

        setPreferredSize(new java.awt.Dimension(500, 300));

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel1.setText("Add math channel");

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(chanArray));

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(functions));

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(chanArray));

        jLabel2.setText("Name");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(138, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(43, 43, 43)
                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(121, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
