/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package math;

import channel.Channel;

/**
 * Class for calibrating the raw data.
 * @author Lauritz Møllersen
 */
public abstract class Calibrator {

    /**
     * Method to calibrate raw data using polynoms.
     * @param chan 
     */
    public static void calibrate(Channel chan) {
        Polynomial polynoms = chan.getPolynomials();
        if (polynoms != null) {
            double[] values = chan.getValues();
            final int size = values.length;
            double[] tempValues = new double[size];
            double tempDouble = 0.0;
            double r = 0.0;
            switch (polynoms.size()) {
                case 1: {
                    final double pol0 = polynoms.get(0);
                    for (int i = 0; i < size; i++) {
                        tempValues[i] = values[i] + pol0;
                    }
                    break;
                }
                case 2: {
                    final double pol0 = polynoms.get(0);
                    final double pol1 = polynoms.get(1);
                    for (int i = 0; i < size; i++) {
                        tempDouble = values[i];
                        r = pol1;
                        r = tempDouble * r + pol0;
                        tempValues[i] = r;
                    }
                    break;
                }
                case 3: {
                    final double pol0 = polynoms.get(0);
                    final double pol1 = polynoms.get(1);
                    final double pol2 = polynoms.get(2);
                    for (int i = 0; i < size; i++) {
                        tempDouble = values[i];
                        r = pol2;
                        r = tempDouble * r + pol1;
                        r = tempDouble * r + pol0;
                        tempValues[i] = r;
                    }
                    break;
                }
                case 4: {
                    final double pol0 = polynoms.get(0);
                    final double pol1 = polynoms.get(1);
                    final double pol2 = polynoms.get(2);
                    final double pol3 = polynoms.get(3);
                    for (int i = 0; i < size; i++) {
                        tempDouble = values[i];
                        r = pol3;
                        r = tempDouble * r + pol2;
                        r = tempDouble * r + pol1;
                        r = tempDouble * r + pol0;
                        tempValues[i] = r;
                    }
                    break;
                }
                case 5: {
                    final double pol0 = polynoms.get(0);
                    final double pol1 = polynoms.get(1);
                    final double pol2 = polynoms.get(2);
                    final double pol3 = polynoms.get(3);
                    final double pol4 = polynoms.get(4);
                    for (int i = 0; i < size; i++) {
                        tempDouble = values[i];
                        r = pol4;
                        r = tempDouble * r + pol3;
                        r = tempDouble * r + pol2;
                        r = tempDouble * r + pol1;
                        r = tempDouble * r + pol0;
                        tempValues[i] = r;
                    }
                    break;
                }
                case 6: {
                    final double pol0 = polynoms.get(0);
                    final double pol1 = polynoms.get(1);
                    final double pol2 = polynoms.get(2);
                    final double pol3 = polynoms.get(3);
                    final double pol4 = polynoms.get(4);
                    final double pol5 = polynoms.get(5);
                    for (int i = 0; i < size; i++) {
                        tempDouble = values[i];
                        r = pol5;
                        r = tempDouble * r + pol4;
                        r = tempDouble * r + pol3;
                        r = tempDouble * r + pol2;
                        r = tempDouble * r + pol1;
                        r = tempDouble * r + pol0;
                        tempValues[i] = r;
                    }
                    break;
                }
                case 7: {
                    final double pol0 = polynoms.get(0);
                    final double pol1 = polynoms.get(1);
                    final double pol2 = polynoms.get(2);
                    final double pol3 = polynoms.get(3);
                    final double pol4 = polynoms.get(4);
                    final double pol5 = polynoms.get(5);
                    final double pol6 = polynoms.get(6);
                    for (int i = 0; i < size; i++) {
                        tempDouble = values[i];
                        r = pol6;
                        r = tempDouble * r + pol5;
                        r = tempDouble * r + pol4;
                        r = tempDouble * r + pol3;
                        r = tempDouble * r + pol2;
                        r = tempDouble * r + pol1;
                        r = tempDouble * r + pol0;
                        tempValues[i] = r;
                    }
                    break;
                }
            }
            chan.setCalibratedValues(tempValues);
        }
    }
}
