/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package plugin.notepad;

import error.ErrorLogger;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.TextArea;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.TextEvent;
import java.awt.event.TextListener;
import java.util.ArrayList;
import javax.swing.JFrame;
import javax.swing.JPanel;
import plugin.DefaultPlugin;
import plugin.Plugin;
import plugin.PluginInitException;
import project.Project;
import view.View;

/**
 *
 * @author Lauritz Møllersen
 */
public class NotepadPlugin extends DefaultPlugin {

    private String notes = "";
    private JPanel jpanel;
    private JFrame jframe;
    private Project p;
    private TextArea ta;
    private javax.swing.JTextArea editor;
    private javax.swing.JScrollPane editorScroll;
    private JPanel propertiesPanel;

    /**
     * 
     */
    public NotepadPlugin() {
    }

    @Override
    public void init(View v) throws PluginInitException {

        for (Plugin p : v.getPlugins()) {
            if (p.getClass().equals(this.getClass()) && !this.equals(p)) {
                ErrorLogger.addError(new error.Error("Plugin initialization error", "The target view already contains a notepad plugin."));

                throw new PluginInitException();
            }
        }
        super.init(v);
        p = getParentProject();

        notes = p.getNotes();
        propertiesPanel = new JPanel();
        jpanel = new JPanel(new BorderLayout());
        ta = new TextArea(notes, 0, 0, TextArea.SCROLLBARS_VERTICAL_ONLY);
        ta.setFont(new Font("Arial", Font.PLAIN, 14)); // set a default font for the TextArea
        ta.setPreferredSize(new Dimension(400, 500));
        jpanel.add(ta);
        ta.addTextListener(new TL());
        ta.addFocusListener(new FL());
    }

    class TL implements TextListener {

        @Override
        public void textValueChanged(TextEvent e) {
            p.setNotes(ta.getText());
        }
    }

    class FL implements FocusListener {

        @Override
        public void focusLost(FocusEvent e) {
            //
        }

        @Override
        public void focusGained(FocusEvent e) {
            ta.setText(p.getNotes());
        }
    }

    /**
     * Get the main GUI component of the Plugin.
     * @return GUI component.
     */
    @Override
    public JPanel getPluginPanel() {
        return jpanel;
    }

    /**
     * Get the property GUI component of the Plugin. 
     * @return GU /**I component.
     */
    public Component getPropertiesPanel() {
        return propertiesPanel;
    }

    /**
     * 
     * @return
     */
    @Override
    public boolean isCursorLinked() {
        return false;
    }
}