/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package plugin.playback;

import error.ErrorLogger;
import java.awt.Component;
import javax.swing.JPanel;
import view.View;
import plugin.DefaultPlugin;
import plugin.Plugin;
import error.Error;
import plugin.PluginInitException;
import parser.Constants;

/**
 *
 * @author Per Øyvind
 */
public class PlaybackPlugin extends DefaultPlugin {

    private static final long serialVersionUID = 1L;
    private PlayBackPanel panel;
    private PlaybackThread playBackThread;
    private JPanel propertiesPanel;

    /**
     * 
     */
    public void stopPlayback() {
        stop();
    }

    @Override
    public void init(View v) throws PluginInitException {

        super.init(v);
        for (Plugin p : v.getPlugins()) {
            if (p.getClass().equals(this.getClass()) && !this.equals(p)) {
                ErrorLogger.addError(new Error("Plugin initialization error", "The target view already contains a playback plugin."));

                throw new PluginInitException();
            }
            if (v.getParentProject().getChannelType(Constants.CHAN_TIME) == null) {
                ErrorLogger.addError(new Error("Plugin initialization error", "No data available."));

                throw new PluginInitException();
            }
        }
        propertiesPanel = new JPanel();
        panel = new PlayBackPanel();
        panel.init(this);
    }

    @Override
    public Component getPluginPanel() {
        return panel;
    }

    @Override
    public Component getPropertiesPanel() {
        return propertiesPanel;
    }

    /**
     * 
     * @param position
     */
    @Override
    public synchronized void setCursorPosition(int position) {
        super.setCursorPosition(position);
        panel.updatePositionText(position);
    }

    /**
     * 
     */
    public void start() {
        playBackThread = new PlaybackThread(
                this,
                getParentView().getGlobalCursorPosition(),
                getParentView().getParentProject().getChannelType(Constants.CHAN_TIME).getValues().length,
                0,
                getParentProject().getHz(),
                1);
        playBackThread.start();
    }

    /**
     * 
     */
    public void stop() {
        if (playBackThread != null) {
            playBackThread.stop();
        }
    }

    /**
     * 
     * @param fps
     */
    public void setFPS(double fps) {
        panel.updateFPS(fps);
    }
}
