/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package plugin.playback;

import java.lang.reflect.InvocationTargetException;
import javax.swing.SwingUtilities;
import plugin.Plugin;

/**
 *
 * @author Per Øyvind
 */
public class PlaybackThread implements Runnable {

    private int start;
    private int stop;
    private PlaybackPlugin pbp;
    private int lineNumber;
    private long sleep;
    private int hz;
    private Thread t;
    private boolean running = false;
    FPSEstimator fps;
    private double speed;
    private double cap;

    PlaybackThread(PlaybackPlugin pbp, int start, int stop, int sleep, int hz, double speed) {
        this.pbp = pbp;
        this.start = start;
        this.stop = stop;
        this.sleep = sleep;
        this.hz = hz;
        this.lineNumber = start;
        this.fps = new FPSEstimator();
        this.speed = speed;
        this.cap = -12;
    }

    @Override
    public void run() {
        long t0 = System.currentTimeMillis();
        for (Plugin p : pbp.getParentView().getPlugins()) {
            p.startPlayback();
        }
        while (this.lineNumber <= this.stop && running) {
            long t1 = System.currentTimeMillis();
            long timePassed = (t1 - t0) * (long) speed;
            lineNumber = start + (int) ((timePassed * hz) / 1000);
            try {
                SwingUtilities.invokeAndWait(
                        new Runnable() {

                            @Override
                            public void run() {
                                pbp.getParentView().setGlobalCursorPosition(lineNumber);
                            }
                        });
            } catch (InterruptedException ex) {
            } catch (InvocationTargetException ex) {
            }
            try {
                Thread.sleep(sleep);
            } catch (InterruptedException ex) {
            }
            long timeConsumed = System.currentTimeMillis() - t1;
            double d = fps.addSample((int) timeConsumed);
            pbp.setFPS(d);
            if (d - cap > 0) {
                sleep = (long) (d - cap);
            }
            sleep = 0;

        }
        for (Plugin p : pbp.getParentView().getPlugins()) {
            p.stopPlayback();
        }
    }

    /**
     * 
     */
    public void start() {
        if (t == null) {
            t = new Thread(this);
            this.running = true;
            t.start();
        }
    }

    /**
     * 
     */
    public void stop() {
        this.running = false;

    }
}
