/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * PropertiesPanel.java
 *
 * Created on May 27, 2012, 1:55:23 PM
 */
package plugin.xy;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import parser.Constants;

/**
 *
 * @author Per Øyvind
 */
public class PropertiesPanel extends javax.swing.JPanel implements MouseListener, ActionListener, FocusListener {

    private final XYChartPlugin lcp;

    /** Creates new form PropertiesPanel
     * @param lcp 
     */
    public PropertiesPanel(XYChartPlugin lcp) {
        this.lcp = lcp;
        initComponents();

        channelSelectionPanel1.addMouseListener(this);
        channelSelectionPanel1.addActionListener(this);
        segmentSelectionPanel1.addMouseListener(this);
        segmentSelectionPanel1.addActionListener(this);
        generalPropPanel1.addActionListener(this);
        generalPropPanel1.addFocusListener(this);
        colorSelectionPanel2.addMouseListener(this);


    }

    /**
     * 
     */
    public void setup() {
        channelsChanged();
        lapsChanged();
        segmentsChanged();
        linkCursorChanged();

        lapColorsChanged();
        titleChanged();
    }

    /**
     * 
     */
    public void segmentsChanged() {
        segmentSelectionPanel1.segmentsChanged(lcp.getParentProject().getSegmentation().getAmountOfSegments() + 1, lcp.getSelectedSegments());
    }

    /**
     * 
     */
    public void channelsChanged() {
        channelSelectionPanel1.channelsChanged(lcp.getParentProject().getChanStrings(), lcp.getParentProject().getMathChanStrings(),
                lcp.getXAxis(), lcp.getYAxis());
    }

    /**
     * 
     */
    public void lapsChanged() {
        segmentSelectionPanel1.lapsChanged(lcp.getParentProject().getSegmentation().getAmountOfLaps(), lcp.getSelectedLaps());
        lapColorsChanged();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane4 = new javax.swing.JScrollPane();
        colorSelectionPanel1 = new ColorSelectionPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        generalPropPanel1 = new GeneralPropPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        channelSelectionPanel1 = new ChannelSelectionPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        segmentSelectionPanel1 = new SegmentSelectionPanel();
        colorSelectionPanel2 = new ColorSelectionPanel();

        javax.swing.GroupLayout colorSelectionPanel1Layout = new javax.swing.GroupLayout(colorSelectionPanel1);
        colorSelectionPanel1.setLayout(colorSelectionPanel1Layout);
        colorSelectionPanel1Layout.setHorizontalGroup(
                colorSelectionPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGap(0, 259, Short.MAX_VALUE));
        colorSelectionPanel1Layout.setVerticalGroup(
                colorSelectionPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGap(0, 466, Short.MAX_VALUE));

        jScrollPane4.setViewportView(colorSelectionPanel1);

        jScrollPane1.setViewportView(generalPropPanel1);

        jTabbedPane1.addTab("General", jScrollPane1);

        jScrollPane2.setViewportView(channelSelectionPanel1);

        jTabbedPane1.addTab("Channels", jScrollPane2);

        jScrollPane3.setViewportView(segmentSelectionPanel1);

        jTabbedPane1.addTab("Segments", jScrollPane3);
        jTabbedPane1.addTab("Coloring", colorSelectionPanel2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 287, Short.MAX_VALUE));
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 498, Short.MAX_VALUE));
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private ChannelSelectionPanel channelSelectionPanel1;
    private ColorSelectionPanel colorSelectionPanel1;
    private ColorSelectionPanel colorSelectionPanel2;
    private GeneralPropPanel generalPropPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private SegmentSelectionPanel segmentSelectionPanel1;
    // End of variables declaration//GEN-END:variables
    @Override
    public void mouseClicked(MouseEvent event) {
        if (event.getSource() instanceof CheckList) {
            CheckList list = (CheckList) event.getSource();
            // Get index of item clicked
            int index = list.locationToIndex(event.getPoint());
            CheckListItem item = (CheckListItem) list.getModel().getElementAt(index);
            // Toggle selected state
            item.setSelected(!item.isSelected());

            if (list.getName().equals("xchannels") || list.getName().equals("xmathchannels")) {
                lcp.setChannelSelection(item.toString(), "x", true);
            } else if (list.getName().equals("ychannels") || list.getName().equals("ymathchannels")) {
                lcp.setChannelSelection(item.toString(), "y", true);
            } else if (list.getName().equals("laps")) {
                int lap = index + 1;
                lcp.setLapSelection(lap, item.isSelected(), true);
            } else if (list.getName().equals("segments")) {
                int segment = index + 1;
                lcp.setSegmentSelection(segment, item.isSelected(), true);
            }
            // Repaint cell
            list.repaint(list.getCellBounds(index, index));
        } else if (event.getSource() instanceof ColorList) {
            ColorList list = (ColorList) event.getSource();
            int index = list.locationToIndex(event.getPoint());
            ColorListItem item = (ColorListItem) list.getModel().getElementAt(index);
            Color c = item.getColor();
            if (list.getName().equals("lapcolors")) {

                Color newColor = JColorChooser.showDialog(
                        null,
                        "Choose Lap Color",
                        c);
                if (newColor != null && newColor != c) {
                    lcp.getParentProject().setLapColor(index + 1, newColor, true);
                }
            }
        }

    }

    @Override
    public void mousePressed(MouseEvent e) {
        //  throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void mouseReleased(MouseEvent e) {
        //  throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void mouseEntered(MouseEvent e) {
        //  throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void mouseExited(MouseEvent e) {
        // throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() instanceof JCheckBox) {
            JCheckBox box = (JCheckBox) e.getSource();
            if (box.getName().equals("linkcursor")) {
                lcp.setCursorLinked(box.isSelected(), true);
            }

        } else if (e.getSource() instanceof JTextField) {
            JTextField txtfield = (JTextField) e.getSource();
            if (txtfield.getName().equals("title")) {
                lcp.setTitle(txtfield.getText(), true);
            }
        }

    }

    /**
     * 
     */
    public void titleChanged() {
        generalPropPanel1.titleChanged(lcp.getTitle());
    }

    /**
     * 
     */
    public void linkCursorChanged() {
        generalPropPanel1.linkCursorChanged(lcp.isCursorLinked());
    }

    /**
     * 
     */
    public void lapColorsChanged() {
        int laps = lcp.getParentProject().getSegmentation().getAmountOfLaps();
        Color[] colors = new Color[laps];
        for (int i = 0; i < laps; i++) {
            colors[i] = lcp.getParentProject().getLapColor(i + 1);
        }
        colorSelectionPanel2.lapColorsChanged(laps, colors);
    }

    @Override
    public void focusGained(FocusEvent e) {
    }

    @Override
    public void focusLost(FocusEvent e) {
        if (e.getSource() instanceof JTextField) {
            JTextField txtfield = (JTextField) e.getSource();
            if (txtfield.getName().equals("title")) {
                lcp.setTitle(txtfield.getText(), true);
            }
        }
    }
}
